#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Ivan Jose Cernicharo Ortiz (ivan.cernicharo@bsc.es)
#             -
#             -
#

import sys
import logging
import os
import subprocess

# Check grid description, 1 degree or whatelse
# This will be checked using CDO

class spatial_consistency_test:

    def __init__(self,path,type=None):
        self.type = type
        self.path = path
        self.files = self.list_files_folder()

    def list_files_folder(self):
        list_files = []
        
        if os.path.exists(self.path) and os.path.isdir(self.path):
            for root, dirs, files in os.walk(self.path):
                    for f in files:
                        if f.endswith("grib") or f.endswith("nc"):
                            list_files.append(os.path.join(root,f))
            
            return sorted(list_files)
        else:
            raise Exception('\n\tGiven path is not a valid path\n')

    def netcdf_check(self,args):
        print('WILL BE READY SOON')

    def grib_check(self,args):
        print('WILL BE READY SOON')


    def initiate_logging(self):
        # Initiate the logging
        time0 = self.timefortitle
        path_logs = os.path.join(
            '/data',
            'DQC_LOGS'
        )

        if not os.path.exists(path_logs):
            os.makedirs(path_logs)

        default_log_name = '_'.join(
            [
                'LOG_TEST04_SPATIAL_CONSISTENCY_CHECK',
                (self.type).upper(),
                time0,
                '.log'
            ]
        )

        default_path = os.path.join(
            path_logs,
            default_log_name
        )
        
        logging.basicConfig(
            filename=default_path,
            format='%(levelname)s:%(asctime)s:%(message)s', 
            level=logging.INFO
        )

        stringA = '\n' + '#'*80 + '\n' + '#'*80
        stringA += '\n RUNNING SPATIAL CONSISTENCY TEST FOR FOLDER:'
        stringA += '\n ' + self.path
        stringA += '\n AGAINST ' + (self.type).upper() + ' DQC '
        stringA += '\n EXECUTION TIME: ' + self.timeforinfo
        stringA += '\n' + '#'*80

    def main(self):
        if self.type != None:

            listfiles = []

            if self.type == 'netcdf':
                listfiles = [item for item in self.files if item.endswith('.nc')]
                
                if listfiles != []:
                    self.check(self,gribfiles)
                else:
                    raise Exception('No files in the given input')

            if self.type == 'grib':
                listfiles = [item for item in self.files if item.endswith('.grib')]

                if listfiles != []:
                    self.check(self,gribfiles)
                else:
                    raise Exception('No files in the given input')

        else:
            sys.exit()

if __name__ == "__main__":
    sys.exit()
